# Generated vagrant file
#
# -*- mode: ruby -*-
# vi: set ft=ruby :


Vagrant.configure("2") do |config|

   # device: br
  config.vm.define "br" do |device|
    device.vm.network :private_network, ip: "172.18.0.1", virtualbox__intnet: "BR"
    device.vm.network :public_network, ip: " 172.18.10.1", netmask: "24"
    device.vm.hostname = "br"
    device.vm.box = "generic/debian10"
    device.vm.provider "virtualbox" do |vb|
      vb.memory = 256
      vb.cpus = 1
    end
  end

  # device: R
  config.vm.define "R" do |device|
    device.vm.network :private_network, ip: "209.165.200.1", virtualbox__intnet: "web-R", netmask: "24"
    device.vm.network :private_network, ip: "192.168.3.1", virtualbox__intnet: "user-attacker-R", netmask: "24"
    device.vm.network :private_network, ip: "172.18.0.5", virtualbox__intnet: "BR", netmask: "24"
    device.vm.hostname = "R"
    device.vm.box = "generic/debian10"
    device.vm.provider "virtualbox" do |vb|
      vb.memory = 256
      vb.cpus = 1
    end
  end
  
  # device: web
  config.vm.define "web" do |device|
    device.vm.hostname = "web"
    device.vm.box = "ubuntu/xenial64"
    device.vm.box_check_update = false
    device.vm.network :private_network, ip: "209.165.200.11", virtualbox__intnet: "web-R", netmask: "24"
    device.vm.provider "virtualbox" do |vb|
      vb.cpus = 2
      vb.memory = 2048
    end
  end

  # device: attacker
  config.vm.define "attacker" do |device|
    device.vm.hostname = "attacker"
    device.vm.box = "kalilinux/rolling"
    device.vm.boot_timeout = 1000
    device.vm.box_check_update = false
    device.vm.network :private_network, ip: "192.168.3.5", virtualbox__intnet: "user-attacker-R", netmask: "24"
  end

  # device: user
  config.vm.define "user" do |device|
    device.vm.hostname = "user"
    device.vm.box = "milbuild/graphical-ubuntu16"
    device.vm.box_check_update = false
    device.vm.network :private_network, ip: "192.168.3.3", virtualbox__intnet: "user-attacker-R", netmask: "24"
    device.vm.provider "virtualbox" do |vb|
      vb.cpus = 1
      vb.memory = 2048
    end
  end

  # basic ansible configuration of devices and networks
  config.vm.provision :ansible do |ansible|
    ansible.playbook = "base_provisioning/device_configuration.yml"
    ansible.verbose = true
    ansible.extra_vars = {
      ansible_python_interpreter: "/usr/bin/python3",
    }
  end


  # user configuration of devices with ansible
  config.vm.provision :ansible do |ansible|
    ansible.playbook = "provisioning/playbook.yml"
    ansible.verbose = true
    ansible.extra_vars = {
      ansible_python_interpreter: "/usr/bin/python3",
    }
  end

  
end
